Up

# NSWindow

### Authors

Scott Christley (`scottc@net-community.com`)
Felipe A. Rodriguez (`far@ix.netcom.com`)
Richard Frith-Macdonald (`richard@brainstorm.co.uk`)

> The window class

Copyright: (C) 1996 Free Software Foundation, Inc.

### Contents -

1. NSWindow
2. Software documentation for the NSObject(NSWindowDelegate) informal protocol
3. Software documentation for the NSWindow(GNUstepBackend) category
4. Software documentation for the NSWindow(GNUstepTextView) category
5. Software documentation for the NSWindow(Toolbar) category

# NSWindow

Instances of the NSWindow class handle on-screen windows, their associated NSViews, and events generate by the user. An NSWindow's size is defined by its frame rectangle, which encompasses its entire structure, and its content rectangle, which includes only the content.

Every NSWindow has a content view, the NSView which forms the root of the window's view hierarchy. This view can be set using the `setContentView:` method, and accessed through the `contentView` method. `setContentView:` replaces the default content view created by NSWindow.

Other views may be added to the window by using the content view's `addSubview:` method. These subviews can also have subviews added, forming a tree structure, the view hierarchy. When an NSWindow must display itself, it causes this hierarchy to draw itself. Leaf nodes in the view hierarchy are drawn last, causing them to potentially obscure views further up in the hierarchy.

A delegate can be specified for an NSWindow, which will receive notifications of events pertaining to the window. The delegate is set using `setDelegate:`, and can be retrieved using `delegate`. The delegate can restrain resizing by implementing the `windowWillResize: toSize:` method, or control the closing of the window by implementing `windowShouldClose:`.

## NSWindow : NSResponder

> Declared in:
>   AppKit/NSWindow.h

> Conforms to:
>   NSCoding

Availability: OpenStep

An NSWindow instance represents a window, panel or menu on the screen.
Each window has a style, which determines how the window is decorated: ie whether it has a border, a title bar, a resize bar, minimise and close buttons.

A window has a frame. This is the frame of the entire window on the screen, including all decorations and borders. The origin of the frame represents its bottom left corner and the frame is expressed in screen coordinates (see NSScreen ).

When a window is created, it has a private NSView instance which fills the entire window frame and whose coordinate system is the same as the base coordinate system of the window (ie zero x and y coordinates are at the bottom left corner of the window, with increasing x and y corresponding to points to the right and above the origin).
This view may be used by the library internals (and theme engines) to draw window decorations if the backend library is not handling the window decorations.

A window always contains a content view which is the highest level view available for public (application) use. This view fills the area of the window inside any decoration/border.
This is the only part of the window that application programmers are allowed to draw in directly.

You can convert between view coordinates and window base coordinates using the [NSView -convertPoint:fromView:] , [NSView -convertPoint:toView:] , [NSView -convertRect:fromView:] , and [NSView -convertRect:toView:] methods with a `nil` view argument.
You can convert between window and screen coordinates using the -convertBaseToScreen: and -convertScreenToBase: methods.

Instance Variables
Method summary

- -_captureMouse:
- -_initDefaults
- -_releaseMouse:
- -_setVisible:
- -_futureFirstResponder
- -runToolbarCustomizationPalette:
- -setToolbar:
- -toggleToolbarShown:
- -toolbar
- +contentRectForFrameRect:styleMask:
- +defaultDepthLimit
- +frameRectForContentRect:styleMask:
- +menuChanged:
- +minFrameWidthWithTitle:styleMask:
- +removeFrameUsingName:
- +standardWindowButton:forStyleMask:
- -acceptsMouseMovedEvents
- -addChildWindow:ordered:
- -allowsToolTipsWhenApplicationIsInactive
- -alphaValue
- -animationResizeTime:
- -areCursorRectsEnabled
- -aspectRatio
- -autorecalculatesKeyViewLoop
- -backgroundColor
- -backingType
- -becomeKeyWindow
- -becomeMainWindow
- -cacheImageInRect:
- -canBecomeKeyWindow
- -canBecomeMainWindow
- -canHide
- -canStoreColor
- -cascadeTopLeftFromPoint:
- -center
- -childWindows
- -close
- -constrainFrameRect:toScreen:
- -contentAspectRatio
- -contentMaxSize
- -contentMinSize
- -contentRectForFrameRect:
- -contentResizeIncrements
- -contentView
- -convertBaseToScreen:
- -convertScreenToBase:
- -counterpart
- -currentEvent
- -dataWithEPSInsideRect:
- -dataWithPDFInsideRect:
- -deepestScreen
- -defaultButtonCell
- -delegate
- -deminiaturize:
- -depthLimit
- -deviceDescription
- -disableCursorRects
- -disableFlushWindow
- -disableKeyEquivalentForDefaultButtonCell
- -discardCachedImage
- -discardCursorRects
- -discardEventsMatchingMask:beforeEvent:
- -display
- -displayIfNeeded
- -displaysWhenScreenProfileChanges
- -dragImage:at:offset:event:pasteboard:source:slideBack:
- -drawers
- -enableCursorRects
- -enableFlushWindow
- -enableKeyEquivalentForDefaultButtonCell
- -endEditingFor:
- -fax:
- -fieldEditor:forObject:
- -firstResponder
- -flushWindow
- -flushWindowIfNeeded
- -frame
- -frameAutosaveName
- -frameRectForContentRect:
- -gState
- -graphicsContext
- -hasDynamicDepthLimit
- -hasShadow
- -hidesOnDeactivate
- -ignoresMouseEvents
- -initWithContentRect:styleMask:backing:defer:
- -initWithContentRect:styleMask:backing:defer:screen:
- -initWithWindowRef:
- -initialFirstResponder
- -invalidateCursorRectsForView:
- -invalidateShadow
- -isAutodisplay
- -isDocumentEdited
- -isExcludedFromWindowsMenu
- -isFlushWindowDisabled
- -isKeyWindow
- -isMainWindow
- -isMiniaturized
- -isMovableByWindowBackground
- -isOneShot
- -isOpaque
- -isReleasedWhenClosed
- -isVisible
- -keyDown:
- -keyViewSelectionDirection
- -level
- -makeFirstResponder:
- -makeKeyAndOrderFront:
- -makeKeyWindow
- -makeMainWindow
- -maxSize
- -minSize
- -miniaturize:
- -miniwindowImage
- -miniwindowTitle
- -mouseLocationOutsideOfEventStream
- -nextEventMatchingMask:
- -nextEventMatchingMask:untilDate:inMode:dequeue:
- -orderBack:
- -orderFront:
- -orderFrontRegardless
- -orderOut:
- -orderWindow:relativeTo:
- -parentWindow
- -performClose:
- -performMiniaturize:
- -performZoom:
- -postEvent:atStart:
- -preservesContentDuringLiveResize
- -print:
- -recalculateKeyViewLoop
- -registerForDraggedTypes:
- -removeChildWindow:
- -representedFilename
- -resetCursorRects
- -resignKeyWindow
- -resignMainWindow
- -resizeFlags
- -resizeIncrements
- -restoreCachedImage
- -saveFrameUsingName:
- -screen
- -selectKeyViewFollowingView:
- -selectKeyViewPrecedingView:
- -selectNextKeyView:
- -selectPreviousKeyView:
- -sendEvent:
- -setAcceptsMouseMovedEvents:
- -setAllowsToolTipsWhenApplicationIsInactive:
- -setAlphaValue:
- -setAspectRatio:
- -setAutodisplay:
- -setAutorecalculatesKeyViewLoop:
- -setBackgroundColor:
- -setBackingType:
- -setCanHide:
- -setContentAspectRatio:
- -setContentMaxSize:
- -setContentMinSize:
- -setContentResizeIncrements:
- -setContentSize:
- -setContentView:
- -setDefaultButtonCell:
- -setDelegate:
- -setDepthLimit:
- -setDisplaysWhenScreenProfileChanges:
- -setDocumentEdited:
- -setDynamicDepthLimit:
- -setExcludedFromWindowsMenu:
- -setFrame:display:
- -setFrame:display:animate:
- -setFrameAutosaveName:
- -setFrameFromString:
- -setFrameOrigin:
- -setFrameTopLeftPoint:
- -setFrameUsingName:
- -setFrameUsingName:force:
- -setHasShadow:
- -setHidesOnDeactivate:
- -setIgnoresMouseEvents:
- -setInitialFirstResponder:
- -setLevel:
- -setMaxSize:
- -setMinSize:
- -setMiniwindowImage:
- -setMiniwindowTitle:
- -setMovableByWindowBackground:
- -setOneShot:
- -setOpaque:
- -setParentWindow:
- -setPreservesContentDuringLiveResize:
- -setReleasedWhenClosed:
- -setRepresentedFilename:
- -setResizeIncrements:
- -setShowsResizeIndicator:
- -setShowsToolbarButton:
- -setTitle:
- -setTitleWithRepresentedFilename:
- -setViewsNeedDisplay:
- -setWindowController:
- -showsResizeIndicator
- -showsToolbarButton
- -standardWindowButton:
- -stringWithSavedFrame
- -styleMask
- -title
- -tryToPerform:with:
- -unregisterDraggedTypes
- -update
- -useOptimizedDrawing:
- -userSpaceScaleFactor
- -validRequestorForSendType:returnType:
- -viewsNeedDisplay
- -windowController
- -windowHandle
- -windowNumber
- -windowRef
- -worksWhenModal
- -zoom:

### contentRectForFrameRect: styleMask:

+ (NSRect) contentRectForFrameRect: (NSRect)aRect styleMask: (unsigned int)aStyle;
Availability: OpenStep
Returns the rectangle which would be used for the content view of a window whose on-screen size and position is specified by aRect and which is decorated with the border and title etc given by aStyle.
Both rectangles are expressed in screen coordinates.

### defaultDepthLimit

+ (NSWindowDepth) defaultDepthLimit;
Availability: OpenStep
Description forthcoming.

### frameRectForContentRect: styleMask:

+ (NSRect) frameRectForContentRect: (NSRect)aRect styleMask: (unsigned int)aStyle;
Availability: OpenStep
Returns the rectangle which would be used for the on-screen frame of a window if that window had a content view occupying the rectangle aRect and was decorated with the border and title etc given by aStyle.
Both rectangles are expressed in screen coordinates.

### menuChanged:

+ (void) menuChanged: (NSMenu*)aMenu;
Availability: MacOS-X 10.0.0
Description forthcoming.

### minFrameWidthWithTitle: styleMask:

+ (float) minFrameWidthWithTitle: (NSString*)aTitle styleMask: (unsigned int)aStyle;
Availability: OpenStep
Returns the smallest frame width that will fit the given title and style. This is the on-screen width of the window including decorations.

### removeFrameUsingName:

+ (void) removeFrameUsingName: (NSString*)name;
Availability: OpenStep
Description forthcoming.

### standardWindowButton: forStyleMask:

+ (NSButton*) standardWindowButton: (NSWindowButton)button forStyleMask: (unsigned int)mask;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### acceptsMouseMovedEvents

- (BOOL) acceptsMouseMovedEvents;
Availability: OpenStep
Description forthcoming.

### addChildWindow: ordered:

- (void) addChildWindow: (NSWindow*)child ordered: (NSWindowOrderingMode)place;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### allowsToolTipsWhenApplicationIsInactive

- (BOOL) allowsToolTipsWhenApplicationIsInactive;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### alphaValue

- (float) alphaValue;
Availability: MacOS-X 10.0.0
Description forthcoming.

### animationResizeTime:

- (NSTimeInterval) animationResizeTime: (NSRect)newFrame;
Availability: MacOS-X 10.0.0
Description forthcoming.

### areCursorRectsEnabled

- (BOOL) areCursorRectsEnabled;
Availability: OpenStep
Description forthcoming.

### aspectRatio

- (NSSize) aspectRatio;
Availability: MacOS-X 10.0.0
Description forthcoming.

### autorecalculatesKeyViewLoop

- (BOOL) autorecalculatesKeyViewLoop;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### backgroundColor

- (NSColor*) backgroundColor;
Availability: OpenStep
Description forthcoming.

### backingType

- (NSBackingStoreType) backingType;
Availability: OpenStep
Description forthcoming.

### becomeKeyWindow

- (void) becomeKeyWindow;
Availability: OpenStep
Description forthcoming.

### becomeMainWindow

- (void) becomeMainWindow;
Availability: OpenStep
Description forthcoming.

### cacheImageInRect:

- (void) cacheImageInRect: (NSRect)aRect;
Availability: MacOS-X 10.0.0
Description forthcoming.

### canBecomeKeyWindow

- (BOOL) canBecomeKeyWindow;
Availability: OpenStep
Returns `YES` if the receiver can be made key. If this method returns `NO`, the window will not be made key. This implementation returns `YES` if the window is resizable or has a title bar. You can override this method to change it's behavior

### canBecomeMainWindow

- (BOOL) canBecomeMainWindow;
Availability: OpenStep
Returns `YES` if the receiver can be the main window. If this method returns `NO`, the window will not become the main window. This implementation returns `YES` if the window is resizable or has a title bar and is visible and is not an NSPanel. You can override this method to change it's behavior

### canHide

- (BOOL) canHide;
Availability: MacOS-X 10.0.0
Description forthcoming.

### canStoreColor

- (BOOL) canStoreColor;
Availability: OpenStep
Description forthcoming.

### cascadeTopLeftFromPoint:

- (NSPoint) cascadeTopLeftFromPoint: (NSPoint)topLeftPoint;
Availability: OpenStep
Positions the receiver at topLeftPoint (or if topLeftPoint is NSZeroPoint, leaves the receiver unmoved except for any necessary constraint to fit on screen).
Returns the position of the top left corner of the receivers content view (after repositioning), so that another window cascaded at the returned point will not obscure the title bar of the receiver.

### center

- (void) center;
Availability: OpenStep
Description forthcoming.

### childWindows

- (NSArray*) childWindows;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### close

- (void) close;
Availability: OpenStep
Description forthcoming.

### constrainFrameRect: toScreen:

- (NSRect) constrainFrameRect: (NSRect)frameRect toScreen: (NSScreen*)screen;
Availability: OpenStep
Given a proposed frame rectangle, return a modified version which will fit inside the screen .

### contentAspectRatio

- (NSSize) contentAspectRatio;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### contentMaxSize

- (NSSize) contentMaxSize;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### contentMinSize

- (NSSize) contentMinSize;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### contentRectForFrameRect:

- (NSRect) contentRectForFrameRect: (NSRect)frameRect;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### contentResizeIncrements

- (NSSize) contentResizeIncrements;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### contentView

- (id) contentView;
Availability: OpenStep
Description forthcoming.

### convertBaseToScreen:

- (NSPoint) convertBaseToScreen: (NSPoint)aPoint;
Availability: OpenStep
Converts aPoint from the base coordinate system of the receiver to a point in the screen coordinate system.
Convert from a point in the base coordinate system for the window to a point in the screen coordinate system.

### convertScreenToBase:

- (NSPoint) convertScreenToBase: (NSPoint)aPoint;
Availability: OpenStep
Converts aPoint from the screen coordinate system to a point in the base coordinate system of the receiver.
Convert from a point in the screen coordinate system to a point in the screen coordinate system of the receiver.

### counterpart

- (NSWindow*) counterpart;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### currentEvent

- (NSEvent*) currentEvent;
Availability: OpenStep
Description forthcoming.

### dataWithEPSInsideRect:

- (NSData*) dataWithEPSInsideRect: (NSRect)rect;
Availability: OpenStep
Description forthcoming.

### dataWithPDFInsideRect:

- (NSData*) dataWithPDFInsideRect: (NSRect)aRect;
Availability: MacOS-X 10.0.0
Description forthcoming.

### deepestScreen

- (NSScreen*) deepestScreen;
Availability: OpenStep
Returns the screen the window is on. Unlike (apparently) OpenStep and MacOSX, GNUstep does not support windows being split across multiple screens

### defaultButtonCell

- (NSButtonCell*) defaultButtonCell;
Availability: MacOS-X 10.0.0
Description forthcoming.

### delegate

- (id) delegate;
Availability: OpenStep
Returns the delegate.

### deminiaturize:

- (void) deminiaturize: (id)sender;
Availability: OpenStep
Causes the window to deminiaturize. Normally you would not call this method directly. A window is automatically deminiaturized by the user via a mouse click event. Does nothing it the window isn't miniaturized.

### depthLimit

- (NSWindowDepth) depthLimit;
Availability: OpenStep
Description forthcoming.

### deviceDescription

- (NSDictionary*) deviceDescription;
Availability: OpenStep
Description forthcoming.

### disableCursorRects

- (void) disableCursorRects;
Availability: OpenStep
Description forthcoming.

### disableFlushWindow

- (void) disableFlushWindow;
Availability: OpenStep
Description forthcoming.

### disableKeyEquivalentForDefaultButtonCell

- (void) disableKeyEquivalentForDefaultButtonCell;
Availability: MacOS-X 10.0.0
Description forthcoming.

### discardCachedImage

- (void) discardCachedImage;
Availability: MacOS-X 10.0.0
Description forthcoming.

### discardCursorRects

- (void) discardCursorRects;
Availability: OpenStep
Description forthcoming.

### discardEventsMatchingMask: beforeEvent:

- (void) discardEventsMatchingMask: (unsigned int)mask beforeEvent: (NSEvent*)lastEvent;
Availability: OpenStep
Description forthcoming.

### display

- (void) display;
Availability: OpenStep
Description forthcoming.

### displayIfNeeded

- (void) displayIfNeeded;
Availability: OpenStep
Description forthcoming.

### displaysWhenScreenProfileChanges

- (BOOL) displaysWhenScreenProfileChanges;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### dragImage: at: offset: event: pasteboard: source: slideBack:

- (void) dragImage: (NSImage*)anImage at: (NSPoint)baseLocation offset: (NSSize)initialOffset event: (NSEvent*)event pasteboard: (NSPasteboard*)pboard source: (id)sourceObject slideBack: (BOOL)slideFlag;
Availability: OpenStep
Description forthcoming.

### drawers

- (NSArray*) drawers;
Availability: MacOS-X 10.0.0
Returns all drawers associated with this window.

### enableCursorRects

- (void) enableCursorRects;
Availability: OpenStep
Description forthcoming.

### enableFlushWindow

- (void) enableFlushWindow;
Availability: OpenStep
Description forthcoming.

### enableKeyEquivalentForDefaultButtonCell

- (void) enableKeyEquivalentForDefaultButtonCell;
Availability: MacOS-X 10.0.0
Description forthcoming.

### endEditingFor:

- (void) endEditingFor: (id)anObject;
Availability: OpenStep
Description forthcoming.

### fax:

- (void) fax: (id)sender;
Availability: OpenStep
Opens the fax panel to allow the user to fax the contents of the window view.

### fieldEditor: forObject:

- (NSText*) fieldEditor: (BOOL)createFlag forObject: (id)anObject;
Availability: OpenStep
Description forthcoming.

### firstResponder

- (NSResponder*) firstResponder;
Availability: OpenStep
Returns the first responder of the window.

### flushWindow

- (void) flushWindow;
Availability: OpenStep
Flush all drawing in the windows buffer to the screen unless the window is not buffered or flushing is not enabled.

### flushWindowIfNeeded

- (void) flushWindowIfNeeded;
Availability: OpenStep
Description forthcoming.

### frame

- (NSRect) frame;
Availability: OpenStep
Returns the frame of the receiver... the rectangular area that the window (including any border, title, and other decorations) occupies on screen.

### frameAutosaveName

- (NSString*) frameAutosaveName;
Availability: OpenStep
Description forthcoming.

### frameRectForContentRect:

- (NSRect) frameRectForContentRect: (NSRect)contentRect;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### gState

- (int) gState;
Availability: OpenStep
Description forthcoming.

### graphicsContext

- (NSGraphicsContext*) graphicsContext;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### hasDynamicDepthLimit

- (BOOL) hasDynamicDepthLimit;
Availability: OpenStep
Description forthcoming.

### hasShadow

- (BOOL) hasShadow;
Availability: MacOS-X 10.0.0
Description forthcoming.

### hidesOnDeactivate

- (BOOL) hidesOnDeactivate;
Availability: OpenStep
Description forthcoming.

### ignoresMouseEvents

- (BOOL) ignoresMouseEvents;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### initWithContentRect: styleMask: backing: defer:

- (id) initWithContentRect: (NSRect)contentRect styleMask: (unsigned int)aStyle backing: (NSBackingStoreType)bufferingType defer: (BOOL)flag;
Availability: OpenStep

Initializes the receiver with a content rect of contentRect, a style mask of styleMask, and a backing store type of backingType.

The style mask values are `NSTitledWindowMask`, for a window with a title, `NSClosableWindowMask`, for a window with a close widget, `NSMiniaturizableWindowMask`, for a window with a miniaturize widget, and `NSResizableWindowMask`, for a window with a resizing widget. These mask values can be OR'd in any combination.

Backing store values are `NSBackingStoreBuffered`, `NSBackingStoreRetained` and `NSBackingStoreNonretained`.

### initWithContentRect: styleMask: backing: defer: screen:

- (id) initWithContentRect: (NSRect)contentRect styleMask: (unsigned int)aStyle backing: (NSBackingStoreType)bufferingType defer: (BOOL)flag screen: (NSScreen*)aScreen;
Availability: OpenStep
Creates a new window with the specified characteristics.
The contentRect is expressed in screen coordinates (for aScreen) and the window frame is calculated from the content rectangle and the window style mask.

Initializes the receiver with a content rect of contentRect, a style mask of styleMask, a backing store type of backingType and a boolean flag. flag specifies whether the window should be created now (`NO`), or when it is displayed (`YES`).

The style mask values are `NSTitledWindowMask`, for a window with a title, `NSClosableWindowMask`, for a window with a close widget, `NSMiniaturizableWindowMask`, for a window with a miniaturize widget, and `NSResizableWindowMask`, for a window with a resizing widget. These mask values can be OR'd in any combination.

Backing store values are `NSBackingStoreBuffered`, `NSBackingStoreRetained` and `NSBackingStoreNonretained`.

### initWithWindowRef:

- (id) initWithWindowRef: (void*)windowRef;
Availability: MacOS-X 10.0.0
Description forthcoming.

### initialFirstResponder

- (NSView*) initialFirstResponder;
Availability: MacOS-X 10.0.0
returns the initial first responder of the receiver.

### invalidateCursorRectsForView:

- (void) invalidateCursorRectsForView: (NSView*)aView;
Availability: OpenStep
Description forthcoming.

### invalidateShadow

- (void) invalidateShadow;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### isAutodisplay

- (BOOL) isAutodisplay;
Availability: OpenStep
Description forthcoming.

### isDocumentEdited

- (BOOL) isDocumentEdited;
Availability: OpenStep
Returns `YES`, if the document has been changed.

### isExcludedFromWindowsMenu

- (BOOL) isExcludedFromWindowsMenu;
Availability: OpenStep
Description forthcoming.

### isFlushWindowDisabled

- (BOOL) isFlushWindowDisabled;
Availability: OpenStep
Description forthcoming.

### isKeyWindow

- (BOOL) isKeyWindow;
Availability: OpenStep
Description forthcoming.

### isMainWindow

- (BOOL) isMainWindow;
Availability: OpenStep
Description forthcoming.

### isMiniaturized

- (BOOL) isMiniaturized;
Availability: OpenStep
Description forthcoming.

### isMovableByWindowBackground

- (BOOL) isMovableByWindowBackground;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### isOneShot

- (BOOL) isOneShot;
Availability: OpenStep
Description forthcoming.

### isOpaque

- (BOOL) isOpaque;
Availability: MacOS-X 10.0.0
Description forthcoming.

### isReleasedWhenClosed

- (BOOL) isReleasedWhenClosed;
Availability: OpenStep
Returns `YES`, if the window is released when it is closed.

### isVisible

- (BOOL) isVisible;
Availability: OpenStep
Description forthcoming.

### keyDown:

- (void) keyDown: (NSEvent*)theEvent;
Availability: OpenStep
Processes theEvent when a key is pressed while within the window.

### keyViewSelectionDirection

- (NSSelectionDirection) keyViewSelectionDirection;
Availability: MacOS-X 10.0.0
Returns the value of _selectionDirection, the direction of the current key view.
See Also:

- -selectKeyViewFollowingView:
- -selectKeyViewPrecedingView:
- -selectNextKeyView:
- -selectPreviousKeyView:

### level

- (int) level;
Availability: OpenStep
Description forthcoming.

### makeFirstResponder:

- (BOOL) makeFirstResponder: (NSResponder*)aResponder;
Availability: OpenStep
This method attempts to make aResponder the first responder.
If aResponder is already the first responder, this method has no effect and simply returns `YES`. Otherwise, the method sends a -resignFirstResponder message to the current first responder (if there is one) and immediately returns `NO` if the current first responder refuses to resign.
Then the method asks aResponder to become first responder by sending it a -becomeFirstResponder message, and if that returns `YES` then this method immediately returns `YES`.
However, if that returns `NO`, the receiver is made the first responder by sending it a -becomeFirstResponder message, and this method returns `NO`.
If aResponder is neither `nil` nor an instance of NSResponder (or of a subclass of NSResponder) then behavior is undefined (though the current GNUstep implementation just returns `NO`).
Makes aResponder the first responder within the receiver.

### makeKeyAndOrderFront:

- (void) makeKeyAndOrderFront: (id)sender;
Availability: OpenStep
Description forthcoming.

### makeKeyWindow

- (void) makeKeyWindow;
Availability: OpenStep
Description forthcoming.

### makeMainWindow

- (void) makeMainWindow;
Availability: OpenStep
Description forthcoming.

### maxSize

- (NSSize) maxSize;
Availability: OpenStep
Description forthcoming.

### minSize

- (NSSize) minSize;
Availability: OpenStep
Description forthcoming.

### miniaturize:

- (void) miniaturize: (id)sender;
Availability: OpenStep
Causes the window to miniaturize, that is the window is removed from the screen and it's counterpart (mini)window is displayed. Does nothing if the window can't be miniaturized (eg. because it's already miniaturized).

### miniwindowImage

- (NSImage*) miniwindowImage;
Availability: OpenStep
Description forthcoming.

### miniwindowTitle

- (NSString*) miniwindowTitle;
Availability: OpenStep
Description forthcoming.

### mouseLocationOutsideOfEventStream

- (NSPoint) mouseLocationOutsideOfEventStream;
Availability: OpenStep
Description forthcoming.

### nextEventMatchingMask:

- (NSEvent*) nextEventMatchingMask: (unsigned int)mask;
Availability: OpenStep
Description forthcoming.

### nextEventMatchingMask: untilDate: inMode: dequeue:

- (NSEvent*) nextEventMatchingMask: (unsigned int)mask untilDate: (NSDate*)expiration inMode: (NSString*)mode dequeue: (BOOL)deqFlag;
Availability: OpenStep
Description forthcoming.

### orderBack:

- (void) orderBack: (id)sender;
Availability: OpenStep
Orders the window to the back of its level. Equivalent to -orderWindow:relativeTo: with arguments NSWindowBelow and 0.

### orderFront:

- (void) orderFront: (id)sender;
Availability: OpenStep
If the application is active, orders the window to the front in its level. If the application is not active, the window is ordered in as far forward as possible in its level without being ordered in front of the key or main window of the currently active app. The current key and main window status is not changed. Equivalent to -orderWindow:relativeTo: with arguments NSWindowAbove and 0.

### orderFrontRegardless

- (void) orderFrontRegardless;
Availability: OpenStep
Orders the window to the front in its level (even in front of the key and main windows of the current app) regardless of whether the app is current or not. This method should only be used in rare cases where the app is cooperating with another app that is displaying data for it. The current key and main window status is not changed.

### orderOut:

- (void) orderOut: (id)sender;
Availability: OpenStep
Orders the window out from the screen. Equivalent to -orderWindow:relativeTo: with arguments NSWindowOut and 0.

### orderWindow: relativeTo:

- (void) orderWindow: (NSWindowOrderingMode)place relativeTo: (int)otherWin;
Availability: OpenStep

If place is NSWindowOut, removes the window from the screen. If place is NSWindowAbove, places the window directly above otherWin, or directly above all windows in its level if otherWin is 0. If place is NSWindowBelow, places the window directly below otherWin, or directly below all windows in its level if otherWin is 0.

If otherWin is zero and the key window is at the same window level as the receiver, the receiver cannot be positioned above the key window.

If place is NSWindowAbove or NSWindowBelow and the application is hidden, the application is unhidden.

### parentWindow

- (NSWindow*) parentWindow;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### performClose:

- (void) performClose: (id)sender;
Availability: OpenStep
Causes the window to close. Calls the windowShouldClose: method on the delegate to determine if it should close and calls shouldCloseWindowController on the controller for the receiver.

### performMiniaturize:

- (void) performMiniaturize: (id)sender;
Availability: OpenStep
Miniaturize the receiver... as long as its style mask includes NSMiniaturizableWindowMask (and as long as the receiver is not an icon or mini window itsself). Calls -miniaturize: to do this.
Beeps if the window can't be miniaturised.
Should ideally provide visual feedback (highlighting the miniaturize button as if it had been clicked) first... but that's not yet implemented.

### performZoom:

- (void) performZoom: (id)sender;
Availability: MacOS-X 10.0.0
Performs the zoom method on the receiver.

### postEvent: atStart:

- (void) postEvent: (NSEvent*)event atStart: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### preservesContentDuringLiveResize

- (BOOL) preservesContentDuringLiveResize;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### print:

- (void) print: (id)sender;
Availability: OpenStep
Opens the print panel to allow the user to print the contents of the window view.

### recalculateKeyViewLoop

- (void) recalculateKeyViewLoop;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### registerForDraggedTypes:

- (void) registerForDraggedTypes: (NSArray*)newTypes;
Availability: OpenStep
Description forthcoming.

### removeChildWindow:

- (void) removeChildWindow: (NSWindow*)child;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### representedFilename

- (NSString*) representedFilename;
Availability: OpenStep
Description forthcoming.

### resetCursorRects

- (void) resetCursorRects;
Availability: OpenStep
Description forthcoming.

### resignKeyWindow

- (void) resignKeyWindow;
Availability: OpenStep
Description forthcoming.

### resignMainWindow

- (void) resignMainWindow;
Availability: OpenStep
Description forthcoming.

### resizeFlags

- (int) resizeFlags;
Availability: OpenStep
Description forthcoming.

### resizeIncrements

- (NSSize) resizeIncrements;
Availability: MacOS-X 10.0.0
Description forthcoming.

### restoreCachedImage

- (void) restoreCachedImage;
Availability: MacOS-X 10.0.0
Description forthcoming.

### saveFrameUsingName:

- (void) saveFrameUsingName: (NSString*)name;
Availability: OpenStep
Description forthcoming.

### screen

- (NSScreen*) screen;
Availability: OpenStep
Returns the screen the window is on.

### selectKeyViewFollowingView:

- (void) selectKeyViewFollowingView: (NSView*)aView;
Availability: MacOS-X 10.0.0
If aView responds to -nextValidKeyView with a new NSView, call -makeFirstResponder: for the returned view.

### selectKeyViewPrecedingView:

- (void) selectKeyViewPrecedingView: (NSView*)aView;
Availability: MacOS-X 10.0.0
If aView responds to -previousValidKeyView with a new NSView, call -makeFirstResponder: for this view.

### selectNextKeyView:

- (void) selectNextKeyView: (id)sender;
Availability: MacOS-X 10.0.0
This method checks if:

- _firstResponder answers to -nextValidKeyView
- _initialFirstResponder answers to -acceptsFirstResponder
- _initialFirstResponder answers to -previousValidKeyView

If any of these checks return a NSView, call -makeFirstResponder: on this NSView.

### selectPreviousKeyView:

- (void) selectPreviousKeyView: (id)sender;
Availability: MacOS-X 10.0.0
This method checks if:

- _firstResponder answers to -previousValidKeyView
- _initialFirstResponder answers to -acceptsFirstResponder
- _initialFirstResponder answers to -previousValidKeyView

If any of these checks return a NSView, call -makeFirstResponder: on this NSView.

### sendEvent:

- (void) sendEvent: (NSEvent*)theEvent;
Availability: OpenStep
Handles mouse and other events sent to the receiver by NSApplication. Do not invoke this method directly.

### setAcceptsMouseMovedEvents:

- (void) setAcceptsMouseMovedEvents: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setAllowsToolTipsWhenApplicationIsInactive:

- (void) setAllowsToolTipsWhenApplicationIsInactive: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setAlphaValue:

- (void) setAlphaValue: (float)windowAlpha;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setAspectRatio:

- (void) setAspectRatio: (NSSize)ratio;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setAutodisplay:

- (void) setAutodisplay: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setAutorecalculatesKeyViewLoop:

- (void) setAutorecalculatesKeyViewLoop: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setBackgroundColor:

- (void) setBackgroundColor: (NSColor*)color;
Availability: OpenStep
Description forthcoming.

### setBackingType:

- (void) setBackingType: (NSBackingStoreType)type;
Availability: OpenStep
Description forthcoming.

### setCanHide:

- (void) setCanHide: (BOOL)flag;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setContentAspectRatio:

- (void) setContentAspectRatio: (NSSize)ratio;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setContentMaxSize:

- (void) setContentMaxSize: (NSSize)size;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setContentMinSize:

- (void) setContentMinSize: (NSSize)size;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setContentResizeIncrements:

- (void) setContentResizeIncrements: (NSSize)increments;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setContentSize:

- (void) setContentSize: (NSSize)aSize;
Availability: OpenStep
Sets the size of the receiver's content view to aSize, implicitly adjusting the size of the receiver's frame to match.

### setContentView:

- (void) setContentView: (NSView*)aView;
Availability: OpenStep
Sets the window's content view to aView, replacing any previous content view.

### setDefaultButtonCell:

- (void) setDefaultButtonCell: (NSButtonCell*)aCell;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setDelegate:

- (void) setDelegate: (id)anObject;
Availability: OpenStep
Sets the delegate to anObject.

### setDepthLimit:

- (void) setDepthLimit: (NSWindowDepth)limit;
Availability: OpenStep
Description forthcoming.

### setDisplaysWhenScreenProfileChanges:

- (void) setDisplaysWhenScreenProfileChanges: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setDocumentEdited:

- (void) setDocumentEdited: (BOOL)flag;
Availability: OpenStep
Set document edit status. If `YES`, then, if the receiver has a close button, the close button will show a broken X. If `NO`, then, if the reciever has a close button, the close button will show a solid X.

### setDynamicDepthLimit:

- (void) setDynamicDepthLimit: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setExcludedFromWindowsMenu:

- (void) setExcludedFromWindowsMenu: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setFrame: display:

- (void) setFrame: (NSRect)frameRect display: (BOOL)flag;
Availability: OpenStep

Sets the frame for the receiver to frameRect and if flag is `YES` causes the window contents to be refreshed. The value of frameRect is the desired on-screen size and position of the window including all border/decoration.

The size of the frame is constrained to the minimum and maximum sizes set for the receiver (if any).
Its position is constrained to be on screen if it is a titled window.

### setFrame: display: animate:

- (void) setFrame: (NSRect)frameRect display: (BOOL)displayFlag animate: (BOOL)animationFlag;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setFrameAutosaveName:

- (BOOL) setFrameAutosaveName: (NSString*)name;
Availability: OpenStep
Description forthcoming.

### setFrameFromString:

- (void) setFrameFromString: (NSString*)string;
Availability: OpenStep
Description forthcoming.

### setFrameOrigin:

- (void) setFrameOrigin: (NSPoint)aPoint;
Availability: OpenStep
Sets the origin (bottom left corner) of the receiver's frame to be the specified point (in screen coordinates).

### setFrameTopLeftPoint:

- (void) setFrameTopLeftPoint: (NSPoint)aPoint;
Availability: OpenStep
Sets the top left corner of the receiver's frame to be the specified point (in screen coordinates).

### setFrameUsingName:

- (BOOL) setFrameUsingName: (NSString*)name;
Availability: OpenStep
Description forthcoming.

### setFrameUsingName: force:

- (BOOL) setFrameUsingName: (NSString*)name force: (BOOL)force;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setHasShadow:

- (void) setHasShadow: (BOOL)hasShadow;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setHidesOnDeactivate:

- (void) setHidesOnDeactivate: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setIgnoresMouseEvents:

- (void) setIgnoresMouseEvents: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setInitialFirstResponder:

- (void) setInitialFirstResponder: (NSView*)aView;
Availability: MacOS-X 10.0.0
Sets the initial first responder of the receiver.

### setLevel:

- (void) setLevel: (int)newLevel;
Availability: OpenStep
Description forthcoming.

### setMaxSize:

- (void) setMaxSize: (NSSize)aSize;
Availability: OpenStep
Description forthcoming.

### setMinSize:

- (void) setMinSize: (NSSize)aSize;
Availability: OpenStep
Description forthcoming.

### setMiniwindowImage:

- (void) setMiniwindowImage: (NSImage*)image;
Availability: OpenStep
Description forthcoming.

### setMiniwindowTitle:

- (void) setMiniwindowTitle: (NSString*)title;
Availability: OpenStep
Description forthcoming.

### setMovableByWindowBackground:

- (void) setMovableByWindowBackground: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setOneShot:

- (void) setOneShot: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setOpaque:

- (void) setOpaque: (BOOL)isOpaque;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setParentWindow:

- (void) setParentWindow: (NSWindow*)window;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setPreservesContentDuringLiveResize:

- (void) setPreservesContentDuringLiveResize: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setReleasedWhenClosed:

- (void) setReleasedWhenClosed: (BOOL)flag;
Availability: OpenStep
If `YES`, then the window is released when the close method is called.

### setRepresentedFilename:

- (void) setRepresentedFilename: (NSString*)aString;
Availability: OpenStep
Description forthcoming.

### setResizeIncrements:

- (void) setResizeIncrements: (NSSize)aSize;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setShowsResizeIndicator:

- (void) setShowsResizeIndicator: (BOOL)show;
Availability: MacOS-X 10.0.0
Description forthcoming.

### setShowsToolbarButton:

- (void) setShowsToolbarButton: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setTitle:

- (void) setTitle: (NSString*)aString;
Availability: OpenStep
Sets the window's title to the string aString.

### setTitleWithRepresentedFilename:

- (void) setTitleWithRepresentedFilename: (NSString*)aString;
Availability: OpenStep
Description forthcoming.

### setViewsNeedDisplay:

- (void) setViewsNeedDisplay: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setWindowController:

- (void) setWindowController: (NSWindowController*)windowController;
Availability: OpenStep
Description forthcoming.

### showsResizeIndicator

- (BOOL) showsResizeIndicator;
Availability: MacOS-X 10.0.0
Description forthcoming.

### showsToolbarButton

- (BOOL) showsToolbarButton;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### standardWindowButton:

- (NSButton*) standardWindowButton: (NSWindowButton)button;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### stringWithSavedFrame

- (NSString*) stringWithSavedFrame;
Availability: OpenStep
Description forthcoming.

### styleMask

- (unsigned int) styleMask;
Availability: OpenStep
Description forthcoming.

### title

- (NSString*) title;
Availability: OpenStep
Returns an NSString containing the text of the window's title.

### tryToPerform: with:

- (BOOL) tryToPerform: (SEL)anAction with: (id)anObject;
Availability: OpenStep
Description forthcoming.

### unregisterDraggedTypes

- (void) unregisterDraggedTypes;
Availability: OpenStep
Description forthcoming.

### update

- (void) update;
Availability: OpenStep
Description forthcoming.

### useOptimizedDrawing:

- (void) useOptimizedDrawing: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### userSpaceScaleFactor

- (float) userSpaceScaleFactor;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### validRequestorForSendType: returnType:

- (id) validRequestorForSendType: (NSString*)sendType returnType: (NSString*)returnType;
Availability: OpenStep
Description forthcoming.

### viewsNeedDisplay

- (BOOL) viewsNeedDisplay;
Availability: OpenStep
Description forthcoming.

### windowController

- (id) windowController;
Availability: OpenStep
Description forthcoming.

### windowHandle

- (void*) windowHandle;
Availability: MacOS-X 10.0.0
Description forthcoming.

### windowNumber

- (int) windowNumber;
Availability: OpenStep
Description forthcoming.

### windowRef

- (void*) windowRef;
Availability: MacOS-X 10.0.0
Description forthcoming.

### worksWhenModal

- (BOOL) worksWhenModal;
Availability: OpenStep
Description forthcoming.

### zoom:

- (void) zoom: (id)sender;
Availability: MacOS-X 10.0.0
Zooms the receiver. This method calls the delegate method windowShouldZoom:toFrame: to determine if the window should be allowed to zoom to full screen.

## Instance Variables for NSWindow Class

### _alphaValue

@protected float _alphaValue;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _autosaveName

@protected NSString* _autosaveName;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _backgroundColor

@protected NSColor* _backgroundColor;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _backingType

@protected NSBackingStoreType _backingType;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _cachedImage

@protected NSCachedImageRep* _cachedImage;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _cachedImageOrigin

@protected NSPoint _cachedImageOrigin;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _children

@protected NSMutableArray* _children;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _contentView

@protected id _contentView;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _context

@protected NSGraphicsContext* _context;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _counterpart

@protected int _counterpart;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _defaultButtonCell

@protected id _defaultButtonCell;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _delegate

@protected id _delegate;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _depthLimit

@protected NSWindowDepth _depthLimit;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _disableFlushWindow

@protected unsigned int _disableFlushWindow;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _f

@protected struct GSWindowFlagsType _f;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _fieldEditor

@protected id _fieldEditor;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _firstResponder

@protected id _firstResponder;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _frame

@protected NSRect _frame;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _futureFirstResponder

@protected id _futureFirstResponder;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _gstate

@protected int _gstate;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _increments

@protected NSSize _increments;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _initialFirstResponder

@protected NSView* _initialFirstResponder;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _lastDragOperationMask

@protected int _lastDragOperationMask;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _lastDragView

@protected id _lastDragView;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _lastPoint

@protected NSPoint _lastPoint;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _lastView

@protected id _lastView;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _maximumSize

@protected NSSize _maximumSize;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _miniaturizedImage

@protected NSImage* _miniaturizedImage;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _miniaturizedTitle

@protected NSString* _miniaturizedTitle;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _minimumSize

@protected NSSize _minimumSize;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _parent

@protected NSWindow* _parent;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _rectNeedingFlush

@protected NSRect _rectNeedingFlush;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _rectsBeingDrawn

@protected NSMutableArray* _rectsBeingDrawn;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _representedFilename

@protected NSString* _representedFilename;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _reserved_1

@protected void* _reserved_1;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _screen

@protected NSScreen* _screen;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _styleMask

@protected unsigned int _styleMask;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _toolbar

@protected NSToolbar* _toolbar;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _windowController

@protected NSWindowController* _windowController;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _windowLevel

@protected int _windowLevel;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _windowNum

@protected int _windowNum;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _windowTitle

@protected NSString* _windowTitle;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _wv

@protected GSWindowDecorationView* _wv;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

# Software documentation for the NSObject(NSWindowDelegate) informal protocol

## NSObject(NSWindowDelegate)

> Declared in:
>   AppKit/NSWindow.h

Availability: OpenStep
Description forthcoming.
Method summary

- -attachedSheet
- -window:willPositionSheet:usingRect:
- -windowDidBecomeKey:
- -windowDidBecomeMain:
- -windowDidChangeScreen:
- -windowDidChangeScreenProfile:
- -windowDidDeminiaturize:
- -windowDidEndSheet:
- -windowDidExpose:
- -windowDidMiniaturize:
- -windowDidMove:
- -windowDidResignKey:
- -windowDidResignMain:
- -windowDidResize:
- -windowDidUpdate:
- -windowShouldClose:
- -windowShouldZoom:toFrame:
- -windowWillBeginSheet:
- -windowWillClose:
- -windowWillMiniaturize:
- -windowWillMove:
- -windowWillResize:toSize:
- -windowWillReturnFieldEditor:toObject:
- -windowWillReturnUndoManager:
- -windowWillUseStandardFrame:defaultFrame:

### attachedSheet

- (NSWindow*) attachedSheet;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### window: willPositionSheet: usingRect:

- (NSRect) window: (NSWindow*)window willPositionSheet: (NSWindow*)sheet usingRect: (NSRect)rect;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### windowDidBecomeKey:

- (void) windowDidBecomeKey: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidBecomeMain:

- (void) windowDidBecomeMain: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidChangeScreen:

- (void) windowDidChangeScreen: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidChangeScreenProfile:

- (void) windowDidChangeScreenProfile: (NSNotification*)aNotification;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### windowDidDeminiaturize:

- (void) windowDidDeminiaturize: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidEndSheet:

- (void) windowDidEndSheet: (NSNotification*)aNotification;
Availability: MacOS-X 10.0.0
Description forthcoming.

### windowDidExpose:

- (void) windowDidExpose: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidMiniaturize:

- (void) windowDidMiniaturize: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidMove:

- (void) windowDidMove: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidResignKey:

- (void) windowDidResignKey: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidResignMain:

- (void) windowDidResignMain: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidResize:

- (void) windowDidResize: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowDidUpdate:

- (void) windowDidUpdate: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowShouldClose:

- (BOOL) windowShouldClose: (id)sender;
Availability: OpenStep
Description forthcoming.

### windowShouldZoom: toFrame:

- (BOOL) windowShouldZoom: (NSWindow*)sender toFrame: (NSRect)aFrame;
Availability: MacOS-X 10.0.0
Description forthcoming.

### windowWillBeginSheet:

- (void) windowWillBeginSheet: (NSNotification*)aNotification;
Availability: MacOS-X 10.0.0
Description forthcoming.

### windowWillClose:

- (void) windowWillClose: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowWillMiniaturize:

- (void) windowWillMiniaturize: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowWillMove:

- (void) windowWillMove: (NSNotification*)aNotification;
Availability: OpenStep
Description forthcoming.

### windowWillResize: toSize:

- (NSSize) windowWillResize: (NSWindow*)sender toSize: (NSSize)frameSize;
Availability: OpenStep
Description forthcoming.

### windowWillReturnFieldEditor: toObject:

- (id) windowWillReturnFieldEditor: (NSWindow*)sender toObject: (id)client;
Availability: OpenStep
Description forthcoming.

### windowWillReturnUndoManager:

- (NSUndoManager*) windowWillReturnUndoManager: (NSWindow*)sender;
Availability: MacOS-X 10.0.0
Description forthcoming.

### windowWillUseStandardFrame: defaultFrame:

- (NSRect) windowWillUseStandardFrame: (NSWindow*)sender defaultFrame: (NSRect)aFrame;
Availability: MacOS-X 10.0.0
Description forthcoming.

# Software documentation for the NSWindow(GNUstepBackend) category

## NSWindow(GNUstepBackend)

> Declared in:
>   AppKit/NSWindow.h

Availability: Not in OpenStep/MacOS-X
Description forthcoming.
Method summary

- -_captureMouse:
- -_initDefaults
- -_releaseMouse:
- -_setVisible:

### _captureMouse:

- (void) _captureMouse: (id)sender;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

### _initDefaults

- (void) _initDefaults;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

### _releaseMouse:

- (void) _releaseMouse: (id)sender;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

### _setVisible:

- (void) _setVisible: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

# Software documentation for the NSWindow(GNUstepTextView) category

## NSWindow(GNUstepTextView)

> Declared in:
>   AppKit/NSWindow.h

Availability: Not in OpenStep/MacOS-X
Description forthcoming.
Method summary

- -_futureFirstResponder

### _futureFirstResponder

- (id) _futureFirstResponder;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

# Software documentation for the NSWindow(Toolbar) category

## NSWindow(Toolbar)

> Declared in:
>   AppKit/NSWindow.h

Availability: OpenStep
Description forthcoming.
Method summary

- -runToolbarCustomizationPalette:
- -setToolbar:
- -toggleToolbarShown:
- -toolbar

### runToolbarCustomizationPalette:

- (void) runToolbarCustomizationPalette: (id)sender;
Availability: OpenStep
Description forthcoming.

### setToolbar:

- (void) setToolbar: (NSToolbar*)toolbar;
Availability: OpenStep
Description forthcoming.

### toggleToolbarShown:

- (void) toggleToolbarShown: (id)sender;
Availability: OpenStep
Description forthcoming.

### toolbar

- (NSToolbar*) toolbar;
Availability: OpenStep
Description forthcoming.

Up